LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;


ENTITY volume_factor_selector IS
	PORT (
		sel : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		factor_out : OUT STD_LOGIC_VECTOR(23 downto 0)
		);
	END volume_factor_selector; 

ARCHITECTURE Behavior OF volume_factor_selector IS
	CONSTANT vol_sqrt2    	: STD_LOGIC_VECTOR(23 DOWNTO 0) := "000101101010000010011110";
	CONSTANT vol_2    		: STD_LOGIC_VECTOR(23 DOWNTO 0) := "001000000000000000000000";
	CONSTANT vol_2sqrt2    	: STD_LOGIC_VECTOR(23 DOWNTO 0) := "001011010100000100111100";
	CONSTANT vol_4    		: STD_LOGIC_VECTOR(23 DOWNTO 0) := "010000000000000000000000";
	BEGIN
	
	-- fixed point signed Q4.20
	factor_out <= 
		"000100000000000000000000" when sel = "0000" else --  0 -> *1
      "000101101010000010011110" when sel = "0001" else --  1 -> *sqrt(2) 0001.011010100000100111100110
      "001000000000000000000000" when sel = "0010" else --  2 -> *2
      "001011010100000100111100" when sel = "0011" else --  3 -> *2*sqrt(2) 0010.110101000001001111001100
      "010000000000000000000000" when sel = "0100" else --  4 -> *4
		"000010110101000001001111" when sel = "1111" else -- -1 -> *1/sqrt(2) 0000.101101010000010011110011
		"000010000000000000000000" when sel = "1110" else -- -2 -> *1/2 
		"000001011010100000100111"	when sel = "1101" else -- -3 -> *1/(2*sqrt(2)) 0000.010110101000001001111001
		"000001000000000000000000"	when sel = "1100" else -- -4 -> *1/4
		"000000000000000000000000";
	
	END Behavior;